Subject: [PATCH 3/3] ARM: sunxi: enable big-endian

From: [email-masked] (Maxime Ripard)
Date: Mon, 25 Jul 2016 14:25:22 +0200

On Fri, Jul 22, 2016 at 03:56:58PM +0200, Michael Weiser wrote:
> Hi Maxime,
> 
> On Fri, Jul 22, 2016 at 11:01:01AM +0200, Maxime Ripard wrote:
> 
> > > At least the Cubieboard2 incarnation of sunxi works correctly in
> > > big-endian mode. Allow the selection of big-endian.
> > With what devices has it been tested? The one doing DMA will probably
> > be the one who fail, have you tested the DMA engine? EMAC? GMAC?
> 
> I've tested with a Cubieboard2 Two-Card (on-board EMMC replaced with a
> second slot). I ran into and fixed DMA problems with stmmac (that's
> GMAC) and sunxi-mmc. Patches are submitted as part of this patchset.
> Endianness fixes to stmmac went much farther than just GMAC but remain
> untested since the Cubieboard2 only uses GMAC.
> 
> I have also successfully used SATA, SPI, UART, security system (with
> cryptodev), the hwmon part of the touchscreen controller, pinctrl with a
> custom interrupt pin via fdt for ethernet via SPI (ENC28J60), watchdog
> as reset controller, onboard RTC and external battery-backed DS1307 RTC
> via I2C. I have not deliberately/synthetically tested the DMA engine. It's
> enabled in the my kernel config and seems happy but was not selected by
> any other driver so seems to be unused currently.

You can test the DMA using the audio components, either the codec, i2s
or spdif. EMAC would be worth testing too.

> I was reluctant to enable big endian support this generically but found
> no better way. Since board specifics are in device tree now, I can't
> really do a && CONFIG_MACH_CUBIEBOARD2 or somesuch. Or can I?

Not really, but it doesn't really matter, since all those drivers are
at the SoC level and should affect all boards equally. And you have
MACH_SUN7I :)

Maxime

-- 
Maxime Ripard, Free Electrons
Embedded Linux and Kernel engineering
http://free-electrons.com
-------------- next part --------------
A non-text attachment was scrubbed...
Name: signature.asc
Type: application/pgp-signature
Size: 819 bytes
Desc: not available
URL: <http://lists.infradead.org/pipermail/linux-arm-kernel/attachments/20160725/5783092e/attachment.sig>